diff --git a/lib/ioctl_wrappers.h b/lib/ioctl_wrappers.h
index 090c125..44f15a0 100644
--- a/lib/ioctl_wrappers.h
+++ b/lib/ioctl_wrappers.h
@@ -131,6 +131,7 @@ struct local_i915_gem_context_param {
 #define LOCAL_CONTEXT_PARAM_GTT_SIZE	0x3
 #define LOCAL_CONTEXT_PARAM_NO_ERROR_CAPTURE	0x4
 #define LOCAL_CONTEXT_PARAM_BANNABLE	0x5
+#define LOCAL_CONTEXT_PARAM_HW_ID	0x6
 	uint64_t value;
 };
 void gem_context_require_bannable(int fd);
diff --git a/tests/intel_perf_dapc.c b/tests/intel_perf_dapc.c
index 92b4dee..23d6ffe 100644
--- a/tests/intel_perf_dapc.c
+++ b/tests/intel_perf_dapc.c
@@ -644,10 +644,28 @@ read_perf_reports(int stream_fd,
 	return true;
 }
 
+static unsigned int
+context_get_hw_ctx_id(int fd, unsigned int ctx)
+{
+	struct local_i915_gem_context_param param;
+
+	memset(&param, 0, sizeof(param));
+	param.context = ctx;
+	param.param = LOCAL_CONTEXT_PARAM_HW_ID;
+	param.value = 0;
+	param.size = 0;
+
+	if (__gem_context_get_param(fd, &param) == -EINVAL)
+		igt_assert(param.value == 0);
+
+	return param.value;
+}
+
 static void
 perf_stream_capture_workload_samples(struct drm_i915_perf_open_param *param,
 				     uint8_t *perf_reports,
-				     int num_reports, int report_size)
+				     int num_reports, int report_size,
+				     uint64_t *hw_ctx_id)
 {
 	drm_intel_bufmgr *bufmgr;
 	drm_intel_context *context0;
@@ -676,6 +694,9 @@ retry:
 	igt_assert_eq(ret, 0);
 	igt_assert_neq(ctx_id, 0xffffffff);
 
+	if (hw_ctx_id)
+		*hw_ctx_id = context_get_hw_ctx_id(drm_fd, ctx_id);
+
 	igt_debug("opening i915-perf stream\n");
 	stream_fd = __perf_open(drm_fd, param);
 
@@ -776,7 +797,8 @@ test_oa_source(void)
 		igt_assert(perf_reports);
 
 		perf_stream_capture_workload_samples(&param, perf_reports,
-						     num_reports, report_size);
+						     num_reports, report_size,
+						     NULL);
 		verify_source(perf_reports, num_reports, report_size);
 		free(perf_reports);
 	}
@@ -784,6 +806,79 @@ test_oa_source(void)
 	igt_waitchildren();
 }
 
+struct oa_ctxid_sample {
+	uint64_t ctx_id;
+	uint8_t oa_report[];
+};
+
+static void
+verify_ctxid(uint8_t *perf_reports, int num_reports, size_t report_size,
+	     uint64_t hw_ctx_id)
+{
+	struct oa_ctxid_sample *sample;
+	uint32_t *oa_report;
+
+	for (int i = 0; i < num_reports; i++) {
+		size_t offset = i * report_size;
+
+		sample = (struct oa_ctxid_sample *) (perf_reports + offset);
+		oa_report = (uint32_t *) sample->oa_report;
+
+		igt_debug("read report: ctx_id= %lu, reason = %x, "
+			  "timestamp = %x\n",
+			  sample->ctx_id, oa_report[0], oa_report[1]);
+
+		if (!oa_report[0])
+			igt_assert(sample->ctx_id == hw_ctx_id);
+	}
+}
+
+static void
+test_perf_ctxid(void)
+{
+	uint64_t properties[] = {
+		/* Include OA reports in samples */
+		DRM_I915_PERF_PROP_SAMPLE_OA, true,
+
+		/* OA unit configuration */
+		DRM_I915_PERF_PROP_OA_METRICS_SET, test_metric_set_id,
+		DRM_I915_PERF_PROP_OA_FORMAT, test_oa_format,
+		DRM_I915_PERF_PROP_OA_EXPONENT, oa_exp_1_millisec,
+
+		/* CS parameters */
+		local_DRM_I915_PERF_PROP_ENGINE, I915_EXEC_RENDER,
+		local_DRM_I915_PERF_PROP_SAMPLE_CTX_ID, true,
+	};
+	struct drm_i915_perf_open_param param = {
+		.flags = I915_PERF_FLAG_FD_CLOEXEC,
+		.num_properties = sizeof(properties) / 16,
+		.properties_ptr = to_user_pointer(properties),
+	};
+
+	/* should be default, but just to be sure... */
+	write_u64_file("/proc/sys/dev/i915/perf_stream_paranoid", 1);
+
+	igt_fork(child, 1) {
+		int prop_size = ARRAY_SIZE(properties);
+		int num_reports = 10;
+		int report_size = get_perf_report_size(properties, prop_size,
+						       test_oa_format);
+		int total_size = num_reports * report_size;
+		uint8_t *perf_reports = malloc(total_size);
+		uint64_t hw_ctx_id;
+
+		igt_assert(perf_reports);
+
+		perf_stream_capture_workload_samples(&param, perf_reports,
+						     num_reports, report_size,
+						     &hw_ctx_id);
+		verify_ctxid(perf_reports, num_reports, report_size, hw_ctx_id);
+		free(perf_reports);
+	}
+
+	igt_waitchildren();
+}
+
 igt_main
 {
 	igt_skip_on_simulation();
@@ -805,6 +900,9 @@ igt_main
 	igt_subtest("oa-source")
 		test_oa_source();
 
+	igt_subtest("perf-ctxid")
+		test_perf_ctxid();
+
 	igt_fixture {
 		close(drm_fd);
 	}